{
TGMCircle demo program

  ES: programa de demostracin de uso del componente TGMCircle
  EN: demo program use of component TGMCircle

=========================================================================
History:

ver 0.1:
  ES- primera versin
  EN- first version
=========================================================================
IMPORTANTE PROGRAMADORES: Por favor, si tienes comentarios, mejoras,
  ampliaciones, errores y/o cualquier otro tipo de sugerencia, envame un correo a:
  gmlib@cadetill.com

IMPORTANT PROGRAMMERS: please, if you have comments, improvements, enlargements,
  errors and/or any another type of suggestion, please send me a mail to:
  gmlib@cadetill.com
=========================================================================

Copyright () 2012, by Xavier Martinez (cadetill)

@author Xavier Martinez (cadetill)
@web  http://www.cadetill.com
}
unit UCircleFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, ExtCtrls,
  GMCircle;

type
  TCircleFrm = class(TForm)
    cbClickable: TCheckBox;
    cbVisible: TCheckBox;
    cbEditable: TCheckBox;
    Label36: TLabel;
    cbStrokeColor: TColorBox;
    eStrokeOpacity: TEdit;
    Label37: TLabel;
    Label38: TLabel;
    eStrokeWeight: TSpinEdit;
    mHTMLContent: TMemo;
    Label1: TLabel;
    cbCloseOtherBeforeOpen: TCheckBox;
    Label2: TLabel;
    Label3: TLabel;
    cbFillColor: TColorBox;
    eFillOpacity: TEdit;
    GroupBox1: TGroupBox;
    Label4: TLabel;
    eLat: TEdit;
    eLng: TEdit;
    Label6: TLabel;
    Label5: TLabel;
    eRadius: TEdit;
    procedure cbClickableClick(Sender: TObject);
    procedure cbEditableClick(Sender: TObject);
    procedure cbVisibleClick(Sender: TObject);
    procedure cbStrokeColorChange(Sender: TObject);
    procedure eStrokeOpacityChange(Sender: TObject);
    procedure eStrokeWeightChange(Sender: TObject);
    procedure cbCloseOtherBeforeOpenClick(Sender: TObject);
    procedure mHTMLContentChange(Sender: TObject);
    procedure cbFillColorChange(Sender: TObject);
    procedure eFillOpacityChange(Sender: TObject);
    procedure eLatChange(Sender: TObject);
    procedure eLngChange(Sender: TObject);
    procedure eRadiusChange(Sender: TObject);
  private
    FGMRec: TGMCircle;
    FIndex: Integer;
  public
    constructor Create(aOwner: TComponent; GMRec: TGMCircle; Index: Integer); reintroduce; virtual;
  end;

var
  CircleFrm: TCircleFrm;

implementation

{$R *.dfm}

{ TPolylineFrm }

procedure TCircleFrm.cbClickableClick(Sender: TObject);
begin
  FGMRec[FIndex].Clickable := cbClickable.Checked;
end;

procedure TCircleFrm.cbCloseOtherBeforeOpenClick(Sender: TObject);
begin
  FGMRec[FIndex].InfoWindow.CloseOtherBeforeOpen := cbCloseOtherBeforeOpen.Checked;
end;

procedure TCircleFrm.cbEditableClick(Sender: TObject);
begin
  FGMRec[FIndex].Editable := cbEditable.Checked;
end;

procedure TCircleFrm.cbFillColorChange(Sender: TObject);
begin
  FGMRec[FIndex].FillColor := cbFillColor.Selected;
end;

procedure TCircleFrm.cbStrokeColorChange(Sender: TObject);
begin
  FGMRec[FIndex].StrokeColor := cbStrokeColor.Selected;
end;

procedure TCircleFrm.cbVisibleClick(Sender: TObject);
begin
  FGMRec[FIndex].Visible := cbVisible.Checked;
end;

constructor TCircleFrm.Create(aOwner: TComponent; GMRec: TGMCircle; Index: Integer);
begin
  inherited Create(aOwner);

  FGMRec := GMRec;
  FIndex := Index;

  cbClickable.Checked := FGMRec[FIndex].Clickable;
  cbEditable.Checked := FGMRec[FIndex].Editable;
  cbVisible.Checked := FGMRec[FIndex].Visible;
  cbStrokeColor.Selected := FGMRec[FIndex].StrokeColor;
  eStrokeOpacity.Text := FloatToStr(FGMRec[FIndex].StrokeOpacity);
  eStrokeWeight.Value := FGMRec[FIndex].StrokeWeight;
  mHTMLContent.Lines.Text := FGMRec[FIndex].InfoWindow.HTMLContent;
  cbCloseOtherBeforeOpen.Checked := FGMRec[FIndex].InfoWindow.CloseOtherBeforeOpen;
  cbFillColor.Selected := FGMRec[FIndex].FillColor;
  eFillOpacity.Text := FloatToStr(FGMRec[FIndex].FillOpacity);
  eLat.Text := FloatToStr(FGMRec[FIndex].Center.Lat);
  eLng.Text := FloatToStr(FGMRec[FIndex].Center.Lng);
  eRadius.Text := FloatToStr(FGMRec[FIndex].Radius);
end;

procedure TCircleFrm.eFillOpacityChange(Sender: TObject);
var
  F: Extended;
begin
  if TryStrToFloat(eFillOpacity.Text, F) then
    FGMRec[FIndex].FillOpacity := F;
end;

procedure TCircleFrm.eLatChange(Sender: TObject);
var
  F: Extended;
begin
  if TryStrToFloat(eLat.Text, F) then
    FGMRec[FIndex].Center.Lat := F;
end;

procedure TCircleFrm.eLngChange(Sender: TObject);
var
  F: Extended;
begin
  if TryStrToFloat(eLng.Text, F) then
    FGMRec[FIndex].Center.Lng := F;
end;

procedure TCircleFrm.eRadiusChange(Sender: TObject);
var
  F: Extended;
begin
  if TryStrToFloat(eRadius.Text, F) then
    FGMRec[FIndex].Radius := F;
end;

procedure TCircleFrm.eStrokeOpacityChange(Sender: TObject);
var
  F: Extended;
begin
  if TryStrToFloat(eStrokeOpacity.Text, F) then
    FGMRec[FIndex].StrokeOpacity := F;
end;

procedure TCircleFrm.eStrokeWeightChange(Sender: TObject);
var
  F: Integer;
begin
  if TryStrToInt(eStrokeWeight.Text, F) then
    FGMRec[FIndex].StrokeWeight := F;
end;

procedure TCircleFrm.mHTMLContentChange(Sender: TObject);
begin
  FGMRec[FIndex].InfoWindow.HTMLContent := mHTMLContent.Lines.Text;
end;

end.
