{
TGMRectangle demo program

  ES: programa de demostracin de uso del componente TGMRectangle
  EN: demo program use of component TGMRectangle

=========================================================================
History:

ver 0.1:
  ES- primera versin
  EN- first version
=========================================================================
IMPORTANTE PROGRAMADORES: Por favor, si tienes comentarios, mejoras,
  ampliaciones, errores y/o cualquier otro tipo de sugerencia, envame un correo a:
  gmlib@cadetill.com

IMPORTANT PROGRAMMERS: please, if you have comments, improvements, enlargements,
  errors and/or any another type of suggestion, please send me a mail to:
  gmlib@cadetill.com
=========================================================================

Copyright () 2012, by Xavier Martinez (cadetill)

@author Xavier Martinez (cadetill)
@web  http://www.cadetill.com
}
unit URectangleFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, ExtCtrls,
  GMRectangle;

type
  TRectangleFrm = class(TForm)
    cbClickable: TCheckBox;
    cbVisible: TCheckBox;
    cbEditable: TCheckBox;
    Label36: TLabel;
    cbStrokeColor: TColorBox;
    eStrokeOpacity: TEdit;
    Label37: TLabel;
    Label38: TLabel;
    eStrokeWeight: TSpinEdit;
    mHTMLContent: TMemo;
    Label1: TLabel;
    cbCloseOtherBeforeOpen: TCheckBox;
    Label2: TLabel;
    Label3: TLabel;
    cbFillColor: TColorBox;
    eFillOpacity: TEdit;
    GroupBox1: TGroupBox;
    Label4: TLabel;
    eNELat: TEdit;
    Label5: TLabel;
    eNELng: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    eSWLat: TEdit;
    Label9: TLabel;
    eSWLng: TEdit;
    procedure cbClickableClick(Sender: TObject);
    procedure cbEditableClick(Sender: TObject);
    procedure cbVisibleClick(Sender: TObject);
    procedure cbStrokeColorChange(Sender: TObject);
    procedure eStrokeOpacityChange(Sender: TObject);
    procedure eStrokeWeightChange(Sender: TObject);
    procedure cbCloseOtherBeforeOpenClick(Sender: TObject);
    procedure mHTMLContentChange(Sender: TObject);
    procedure cbFillColorChange(Sender: TObject);
    procedure eFillOpacityChange(Sender: TObject);
    procedure eNELatChange(Sender: TObject);
    procedure eNELngChange(Sender: TObject);
    procedure eSWLatChange(Sender: TObject);
    procedure eSWLngChange(Sender: TObject);
  private
    FGMRec: TGMRectangle;
    FIndex: Integer;
  public
    constructor Create(aOwner: TComponent; GMRec: TGMRectangle; Index: Integer); reintroduce; virtual;
  end;

var
  RectangleFrm: TRectangleFrm;

implementation

{$R *.dfm}

{ TPolylineFrm }

procedure TRectangleFrm.cbClickableClick(Sender: TObject);
begin
  FGMRec[FIndex].Clickable := cbClickable.Checked;
end;

procedure TRectangleFrm.cbCloseOtherBeforeOpenClick(Sender: TObject);
begin
  FGMRec[FIndex].InfoWindow.CloseOtherBeforeOpen := cbCloseOtherBeforeOpen.Checked;
end;

procedure TRectangleFrm.cbEditableClick(Sender: TObject);
begin
  FGMRec[FIndex].Editable := cbEditable.Checked;
end;

procedure TRectangleFrm.cbFillColorChange(Sender: TObject);
begin
  FGMRec[FIndex].FillColor := cbFillColor.Selected;
end;

procedure TRectangleFrm.cbStrokeColorChange(Sender: TObject);
begin
  FGMRec[FIndex].StrokeColor := cbStrokeColor.Selected;
end;

procedure TRectangleFrm.cbVisibleClick(Sender: TObject);
begin
  FGMRec[FIndex].Visible := cbVisible.Checked;
end;

constructor TRectangleFrm.Create(aOwner: TComponent; GMRec: TGMRectangle; Index: Integer);
begin
  inherited Create(aOwner);

  FGMRec := GMRec;
  FIndex := Index;

  cbClickable.Checked := FGMRec[FIndex].Clickable;
  cbEditable.Checked := FGMRec[FIndex].Editable;
  cbVisible.Checked := FGMRec[FIndex].Visible;
  cbStrokeColor.Selected := FGMRec[FIndex].StrokeColor;
  eStrokeOpacity.Text := FloatToStr(FGMRec[FIndex].StrokeOpacity);
  eStrokeWeight.Value := FGMRec[FIndex].StrokeWeight;
  mHTMLContent.Lines.Text := FGMRec[FIndex].InfoWindow.HTMLContent;
  cbCloseOtherBeforeOpen.Checked := FGMRec[FIndex].InfoWindow.CloseOtherBeforeOpen;
  cbFillColor.Selected := FGMRec[FIndex].FillColor;
  eFillOpacity.Text := FloatToStr(FGMRec[FIndex].FillOpacity);
  eNELat.Text := FloatToStr(FGMRec[FIndex].Bounds.NE.Lat);
  eNELng.Text := FloatToStr(FGMRec[FIndex].Bounds.NE.Lng);
  eSWLat.Text := FloatToStr(FGMRec[FIndex].Bounds.SW.Lat);
  eSWLng.Text := FloatToStr(FGMRec[FIndex].Bounds.SW.Lng);
end;

procedure TRectangleFrm.eFillOpacityChange(Sender: TObject);
var
  F: Extended;
begin
  if TryStrToFloat(eFillOpacity.Text, F) then
    FGMRec[FIndex].FillOpacity := F;
end;

procedure TRectangleFrm.eNELatChange(Sender: TObject);
var
  F: Extended;
begin
  if TryStrToFloat(eNELat.Text, F) then
    FGMRec[FIndex].Bounds.NE.Lat := F;
end;

procedure TRectangleFrm.eNELngChange(Sender: TObject);
var
  F: Extended;
begin
  if TryStrToFloat(eNELng.Text, F) then
    FGMRec[FIndex].Bounds.NE.Lng := F;
end;

procedure TRectangleFrm.eStrokeOpacityChange(Sender: TObject);
var
  F: Extended;
begin
  if TryStrToFloat(eStrokeOpacity.Text, F) then
    FGMRec[FIndex].StrokeOpacity := F;
end;

procedure TRectangleFrm.eStrokeWeightChange(Sender: TObject);
var
  F: Integer;
begin
  if TryStrToInt(eStrokeWeight.Text, F) then
    FGMRec[FIndex].StrokeWeight := F;
end;

procedure TRectangleFrm.eSWLatChange(Sender: TObject);
var
  F: Extended;
begin
  if TryStrToFloat(eSWLat.Text, F) then
    FGMRec[FIndex].Bounds.SW.Lat := F;
end;

procedure TRectangleFrm.eSWLngChange(Sender: TObject);
var
  F: Extended;
begin
  if TryStrToFloat(eSWLng.Text, F) then
    FGMRec[FIndex].Bounds.SW.Lng := F;
end;

procedure TRectangleFrm.mHTMLContentChange(Sender: TObject);
begin
  FGMRec[FIndex].InfoWindow.HTMLContent := mHTMLContent.Lines.Text;
end;

end.
